unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, OleCtrls, Grids, DBGrids, ComCtrls, Variants,
  APL_PSS_API_Lib_TLB;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Product_id: TEdit;
    Product_name: TEdit;
    Product_ver: TEdit;
    ListView1: TListView;
    Label4: TLabel;
    charact_name: TEdit;
    Label6: TLabel;
    charact_unit: TEdit;
    AplPssAPI1: TAplPssAPI;
    Button4: TButton;
    Button5: TButton;
    //StepData: TAplStepDataCtrl;
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure OnCreate(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  pdf : integer; //   
  charact :  variant; //  

  //  
  //    OnCreate
  PssApi     :IAplAPI;
  PssData    :IAplAPI_Data;
  PssFolder  :IAplAPI_Folder;
  PssCateg   :IAplAPI_Category;
  PssDoc     :IAplAPI_Document;
  PssProduct :IAplAPI_Product;
  PssAutoriz :IAplAPI_Autorization;
  PssBPoc    :IAplAPI_BProcess;
  PssCharact :IAplAPI_Characteristic;

implementation

{$R *.DFM}

procedure TForm1.OnCreate(Sender: TObject);
begin
  //    
  PssApi     := AplPssAPI1.DefaultInterface;
  PssData    := PssApi As IAplAPI_Data;
  PssFolder  := PssApi As IAplAPI_Folder;
  PssCateg   := PssApi As IAplAPI_Category;
  PssDoc     := PssApi As IAplAPI_Document;
  PssProduct := PssApi As IAplAPI_Product;
  PssAutoriz := PssApi As IAplAPI_Autorization;
  PssBPoc    := PssApi As IAplAPI_BProcess;
  PssCharact := PssApi As IAplAPI_Characteristic;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
     {     ,  
       ,     ,   }
     PssApi.Connect('','','');

     //     
     PssCharact.LoadCharacteristicDictionary();

end;

procedure TForm1.Button4Click(Sender: TObject);
begin
     {     }
      PssApi.Disconnect()
end;

procedure TForm1.Button2Click(Sender: TObject);
var
          prd : integer;
          id,name,ver : variant;
begin

    if(not PssAPI.IsConnected()) then  begin
      Application.MessageBox('    ','',MB_OK);
      Exit;
      end;

    //  ,     :
     pdf:=PssApi.SelectInstance(255,0,''); // 8 - ,    
     if(pdf=0) then
       begin
           Application.MessageBox('   ','aaa',1);
       end
     else
          begin
          ver:=PssData.GetAttrBN(pdf,'id');         //   
          prd:=PssData.GetAttrBN(pdf,'of_product'); //    
          id:=PssData.GetAttrBN(prd,'id');          //  
          name:=PssData.GetAttrBN(prd,'name');      //  
          Product_id.Text:=id;
          Product_name.Text:=name;
          Product_ver.Text:=ver;
          end;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
buf : variant;
unit_id : variant;
begin
    if(not PssAPI.IsConnected()) then  begin
      Application.MessageBox('    ','',MB_OK);
      Exit;
      end;

    charact:=PssCharact.SelectCharacteristic(0,0);
    if(charact=0) then begin
         charact_name.Text:='';
         charact_unit.Text:='';
      end else begin
         buf:=PssData.GetAttrBN(charact,'name');   //  
         charact_name.Text:=buf;
         unit_id:=PssData.GetAttrBN(charact,'unit'); //    
         buf:=PssData.GetAttrBN(unit_id,'id');           //  . 
         charact_unit.Text:=buf;
      end;
 end;


procedure TForm1.Button3Click(Sender: TObject);
var      i,prd,inst: integer;
         ole_pdfs      : OleVariant;     //   
         ole_countArr  : OleVariant;     //  
         ole_unitArr   : OleVariant;     //   
         pdfs      : variant;     //      (  Delphi)
         countArr  : variant;     //         (  Delphi)
         unitArr   : variant;     //    (  Delphi)

         item :TListItem;
         id,name,ver,unit_id,std,inst_val : variant;
         buf ,buf1: string;
         value :WideString;
begin

    if(not PssAPI.IsConnected()) then  begin
      Application.MessageBox('    ','',MB_OK);
      Exit;
      end;

    if(pdf=0) then  begin
      Application.MessageBox('   ','',MB_OK);
      Exit;
      end;

    if(charact=0) then  begin
      Application.MessageBox('  ','',MB_OK);
      Exit;
      end;


    ListView1.Items.Clear;

     //    
     // pdf-   ,  .  
     //    1 -   ,
     //   0 -   
     PssProduct.DisassemblyProduct(0,0,pdf,ole_pdfs,ole_countArr,ole_unitArr,1);

     //     OLE   
     pdfs:=ole_pdfs;
     countArr:=ole_countArr;
     unitArr:=ole_unitArr;

     //      

     //    
     for i:=VarArrayLowBound(pdfs,1) to VarArrayHighBound(pdfs,1) do
     begin
          item:=ListView1.Items.Insert(1);

          ver:=PssData.GetAttrBN(pdfs[i],'id');         //   
          prd:=PssData.GetAttrBN(pdfs[i],'of_product'); //    
          id:=PssData.GetAttrBN(prd,'id');             //  
          name:=PssData.GetAttrBN(prd,'name');         //  

          item.Caption:=id;
          item.SubItems.Add(name);
          item.SubItems.Add(ver);
          item.SubItems.Add(countArr[i]);
          inst:=unitArr[i];
          if(inst=0) then  item.SubItems.Add('.')
          else begin
             unit_id:=PssData.GetAttrBN(inst,'id'); //    
             item.SubItems.Add(unit_id);
          end;

          //  
          buf:=PssData.GetAttrBN(pdfs[i],'formation_type');

          buf:=PssProduct.StrConvertPdfType2Rus(buf);
          item.SubItems.Add(buf);
          {   :
          if(buf='assembly') then buf := ' '
          else if(buf='material') then buf := ''
          else if(buf='kit') then buf := ''
          else if(buf='komplex') then buf := ''
          else buf := '';
          item.SubItems.Add(buf);
          }

          //  
          buf:=PssData.GetAttrBN(pdfs[i],'make_or_buy');
          buf:=PssProduct.StrConvertMakeOrBuy2Rus(buf);
          item.SubItems.Add(buf);

          {   :
          if(buf='made') then buf := ''
          else if(buf='bought') then buf := ''
          else buf := '?';
          item.SubItems.Add(buf);
          }

          //  
          std:=PssData.GetAttrBN(pdfs[i],'is_standard_part');
          if(std=1) then buf:='' else buf := '';
          item.SubItems.Add(buf);

         //  
          if(charact<>0) then begin
              //  -  
              inst_val:=PssCharact.GetInstCharacteristic(pdfs[i],charact);
              if(inst_val<>0) then begin
                 PssCharact.PrintCharacteristicValue(inst_val,0,value);
                 item.SubItems.Add(value);
               end;
           end;
      end;
 end;


procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //     
  if(PssAPI.IsConnected()) then PssApi.Disconnect();
end;

end.
